Package org.apache.commons.math3.distribution

# Class CauchyDistribution

java.lang.Object
org.apache.commons.math3.distribution.AbstractRealDistribution
org.apache.commons.math3.distribution.CauchyDistribution

All Implemented Interfaces:
  `Serializable`, `RealDistribution`

public class CauchyDistribution extends AbstractRealDistribution
Implementation of the Cauchy distribution.

Since:
  1.1 (changed to concrete class in 3.0)
See Also:
  - Cauchy distribution (Wikipedia)
  - Cauchy Distribution (MathWorld)
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final double`
`DEFAULT_INVERSE_ABSOLUTE_ACCURACY`
Default inverse cumulative probability accuracy.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

## Constructor Summary

Constructors
Constructor
Description
`CauchyDistribution()`
Creates a Cauchy distribution with the median equal to zero and scale equal to one.
`CauchyDistribution(double median, double scale)`
Creates a Cauchy distribution using the given median and scale.
`CauchyDistribution(double median, double scale, double inverseCumAccuracy)`
Creates a Cauchy distribution using the given median and scale.
`CauchyDistribution(RandomGenerator rng, double median, double scale)`
Creates a Cauchy distribution.
`CauchyDistribution(RandomGenerator rng, double median, double scale, double inverseCumAccuracy)`
Creates a Cauchy distribution.

## Method Summary

Modifier and Type
Method
Description
`double`
`cumulativeProbability(double x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double`
`density(double x)`
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double`
`getMedian()`
Access the median.
`double`
`getNumericalMean()`
Use this method to get the numerical value of the mean of this distribution.
`double`
`getNumericalVariance()`
Use this method to get the numerical value of the variance of this distribution.
`double`
`getScale()`
Access the scale parameter.
`protected double`
`getSolverAbsoluteAccuracy()`
Returns the solver absolute accuracy for inverse cumulative computation.
`double`
`getSupportLowerBound()`
Access the lower bound of the support.
`double`
`getSupportUpperBound()`
Access the upper bound of the support.
`double`
`inverseCumulativeProbability(double p)`
Computes the quantile function of this distribution.
`boolean`
`isSupportConnected()`
Use this method to get information about whether the support is connected, i.e.
`boolean`
`isSupportLowerBoundInclusive()`
Whether or not the lower bound of support is in the domain of the density function.
`boolean`
`isSupportUpperBoundInclusive()`
Whether or not the upper bound of support is in the domain of the density function.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, logDensity, probability, probability, reseedRandomGenerator, sample, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY
Default inverse cumulative probability accuracy.

Since:
  2.1
See Also:
  - Constant Field Values

## Constructor Details

### CauchyDistribution

public CauchyDistribution()
Creates a Cauchy distribution with the median equal to zero and scale equal to one.

### CauchyDistribution

public CauchyDistribution(double median, double scale)
Creates a Cauchy distribution using the given median and scale.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `AbstractRealDistribution.sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `median` - Median for this distribution.
  `scale` - Scale parameter for this distribution.

### CauchyDistribution

public CauchyDistribution(double median, double scale, double inverseCumAccuracy)
Creates a Cauchy distribution using the given median and scale.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `AbstractRealDistribution.sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `median` - Median for this distribution.
  `scale` - Scale parameter for this distribution.
  `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Throws:
  `NotStrictlyPositiveException` - if `scale <= 0`.
Since:
  2.1

### CauchyDistribution

public CauchyDistribution(RandomGenerator rng, double median, double scale)
Creates a Cauchy distribution.

Parameters:
  `rng` - Random number generator.
  `median` - Median for this distribution.
  `scale` - Scale parameter for this distribution.
Throws:
  `NotStrictlyPositiveException` - if `scale <= 0`.
Since:
  3.3

### CauchyDistribution

public CauchyDistribution(RandomGenerator rng, double median, double scale, double inverseCumAccuracy)
Creates a Cauchy distribution.

Parameters:
  `rng` - Random number generator.
  `median` - Median for this distribution.
  `scale` - Scale parameter for this distribution.
  `inverseCumAccuracy` - Maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Throws:
  `NotStrictlyPositiveException` - if `scale <= 0`.
Since:
  3.1

## Method Details

### cumulativeProbability

public double cumulativeProbability(double x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

### getMedian

public double getMedian()
Access the median.

Returns:
  the median for this distribution.

### getScale

public double getScale()
Access the scale parameter.

Returns:
  the scale parameter for this distribution.

### density

public double density(double x)
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

### inverseCumulativeProbability

public double inverseCumulativeProbability(double p) throws OutOfRangeException
Computes the quantile function of this distribution. For a random variable `X` distributed according to this distribution, the returned value is

- `inf{x in R | P(Xinvalid input: '<'=x) >= p}` for `0 < p <= 1`,
- `inf{x in R | P(Xinvalid input: '<'=x) > 0}` for `p = 0`.

The default implementation returns

- `RealDistribution.getSupportLowerBound()` for `p = 0`,
- `RealDistribution.getSupportUpperBound()` for `p = 1`.

Returns `Double.NEGATIVE_INFINITY` when `p == 0` and `Double.POSITIVE_INFINITY` when `p == 1`.

Specified by:
  `inverseCumulativeProbability` in interface `RealDistribution`
Overrides:
  `inverseCumulativeProbability` in class `AbstractRealDistribution`
Parameters:
  `p` - the cumulative probability
Returns:
  the smallest `p`-quantile of this distribution (largest 0-quantile for `p = 0`)
Throws:
  `OutOfRangeException` - if `p < 0` or `p > 1`

### getSolverAbsoluteAccuracy

protected double getSolverAbsoluteAccuracy()
Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

Overrides:
  `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
Returns:
  the maximum absolute error in inverse cumulative probability estimates

### getNumericalMean

public double getNumericalMean()
Use this method to get the numerical value of the mean of this distribution. The mean is always undefined no matter the parameters.

Returns:
  mean (always Double.NaN)

### getNumericalVariance

public double getNumericalVariance()
Use this method to get the numerical value of the variance of this distribution. The variance is always undefined no matter the parameters.

Returns:
  variance (always Double.NaN)

### getSupportLowerBound

public double getSupportLowerBound()
Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) > 0}`.

The lower bound of the support is always negative infinity no matter the parameters.

Returns:
  lower bound of the support (always Double.NEGATIVE_INFINITY)

### getSupportUpperBound

public double getSupportUpperBound()
Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) = 1}`.

The upper bound of the support is always positive infinity no matter the parameters.

Returns:
  upper bound of the support (always Double.POSITIVE_INFINITY)

### isSupportLowerBoundInclusive

public boolean isSupportLowerBoundInclusive()
Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

public boolean isSupportUpperBoundInclusive()
Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

public boolean isSupportConnected()
Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`